Subject: Re: [PATCH net] net: stmmac: dwmac4: extend timeout for VLAN Tag register busy bit check

From: Simon Horman <[email-masked]>
Date: Wed, 18 Sep 2024 09:16:32 +0100

On Tue, Sep 17, 2024 at 11:42:06AM -0500, Shenwei Wang wrote:
> Increase the timeout for checking the busy bit of the VLAN Tag register
> from 10µs to 500ms. This change is necessary to accommodate scenarios
> where Energy Efficient Ethernet (EEE) is enabled.
> 
> Overnight testing revealed that when EEE is active, the busy bit can
> remain set for up to approximately 300ms. The new 500ms timeout provides
> a safety margin.
> 
> This modification does not impact normal success path, as the function
> typically returns within 1µs in non-EEE scenarios. The extended timeout
> only affects the failure path.
> 
> Fixes: ed64639bc1e0 ("net: stmmac: Add support for VLAN Rx filtering")
> Signed-off-by: Shenwei Wang <[email-masked]>

Hi Shenwei Wang,

It looks like this function now uses udelay() to busy-wait for up to 500ms.
But 500ms, or indeed 300ms, seems like a long time to tie down a core.  I
wonder if some other sort of mechanism, f.e. involving msleep or delayed
work, should be considered.

...